/*
btnewblk.c Version 0.1.0  Btree add new block during split
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

long btnewblk(btreefmt *bthdr)
   {
   DWORD msgerr;
   long  ofst;
   DWORD loc;
   LPVOID lpMsgBuf;
   bthdr->reason = 0;
   loc = SetFilePointer(bthdr->hndl,
      0L, NULL,
      FILE_END);
   if (loc == UINT_MAX)
      {
      msgerr = GetLastError();
      bthdr->reason = SYS_ERR + msgerr;
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
         FORMAT_MESSAGE_FROM_SYSTEM |
         FORMAT_MESSAGE_IGNORE_INSERTS,
         NULL,             /* source */
         msgerr,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
         (LPTSTR) &lpMsgBuf,
         0,                /* message length */
         NULL);            /* insertion values */
      fprintf(stderr,"btnewblk: %s", lpMsgBuf);
      LocalFree(lpMsgBuf);
      fprintf(stderr,"btnewblk: %s: "
         "SetFilePointer error\n",
         bthdr->dbname);
      return(loc);
      } /* lseek err */
   ofst = (long) loc;
   btputblk(bthdr,ofst,bthdr->blkrght);
   return(ofst);
   } /* btnewblk */
